# SciMLNLSolve.jl

[![Join the chat at https://gitter.im/JuliaDiffEq/Lobby](https://badges.gitter.im/JuliaDiffEq/Lobby.svg)](https://gitter.im/JuliaDiffEq/Lobby?utm_source=badge&utm_medium=badge&utm_campaign=pr-badge&utm_content=badge)
[![Build Status](https://github.com/SciML/SciMLNLSolve.jl/workflows/CI/badge.svg)](https://github.com/SciML/SciMLNLSolve.jl/actions?query=workflow%3ACI)
[![Coverage Status](https://coveralls.io/repos/github/SciML/SciMLNLSolve.jl/badge.svg)](https://coveralls.io/github/SciML/SciMLNLSolve.jl)
[![codecov.io](http://codecov.io/github/SciML/SciMLNLSolve.jl/coverage.svg?branch=master)](http://codecov.io/github/SciML/SciMLNLSolve.jl?branch=master)

SciMLNLSolve.jl is a wrapper library for bringing
[NLsolve.jl](https://github.com/JuliaNLSolvers/NLsolve.jl) into the SciML common interface
for use with NonlinearSolve.jl. For more information on using this library, consult the
documentation for [NonlinearSolve.jl](https://docs.sciml.ai/NonlinearSolve/stable/).

using SciMLNLSolve, LinearAlgebra, Test

# Test the autodiff technique
function f!(fvec, x, p)
    fvec[1] = (x[1] + 3) * (x[2]^3 - 7) + 18
    fvec[2] = sin(x[2] * exp(x[1]) - 1)
end

prob = NonlinearProblem{true}(f!, [0.1; 1.2])
sol = solve(prob, NLSolveJL(autodiff = :forward))

du = zeros(2)
f!(du, sol.u, nothing)
@test maximum(du) < 1e-6

function problem(x, A)
    return x .^ 2 - A
end

function problemJacobian(x, A)
    return diagm(2 .* x)
end

function f!(F, u, p)
    F[1:152] = problem(u, p)
end

function j!(J, u, p)
    J[1:152, 1:152] = problemJacobian(u, p)
end

f = NonlinearFunction(f!)

init = ones(152);
A = ones(152);
A[6] = 0.8

f = NonlinearFunction(f!, jac = j!)

p = A

ProbN = NonlinearProblem(f, init, p)
sol = solve(ProbN, NLSolveJL(), reltol = 1e-8, abstol = 1e-8)

init = ones(Complex{Float64}, 152);
ProbN = NonlinearProblem(f, init, p)
sol = solve(ProbN, NLSolveJL(), reltol = 1e-8, abstol = 1e-8)

using Pkg
using SafeTestsets
using Test

#@test isempty(detect_ambiguities(SciMLBase))

const GROUP = get(ENV, "GROUP", "All")
const is_APPVEYOR = (Sys.iswindows() && haskey(ENV, "APPVEYOR"))

@time begin
    @time @safetestset "NLsolve.jl Basic" include("nlsolve.jl")
    @time @safetestset "NLsolve.jl Autodiff" include("autodiff.jl")
    @time @safetestset "NLsolve.jl FiniteDiff" include("finite_difference.jl")
end

using SciMLNLSolve, Test

# Test the finite differencing technique
function f!(fvec, x, p)
    fvec[1] = (x[1] + 3) * (x[2]^3 - 7) + 18
    fvec[2] = sin(x[2] * exp(x[1]) - 1)
end

prob = NonlinearProblem{true}(f!, [0.1; 1.2])
sol = solve(prob, NLSolveJL(autodiff = :central))

du = zeros(2)
f!(du, sol.u, nothing)
@test maximum(du) < 1e-6

using SciMLNLSolve, Test

# IIP Tests
function f_iip(du, u, p, t)
    du[1] = 2 - 2u[1]
    du[2] = u[1] - 4u[2]
end
u0 = zeros(2)
prob_iip = SteadyStateProblem(f_iip, u0)
abstol = 1e-8

for alg in [NLSolveJL()]
    sol = solve(prob_iip, alg)
    @test sol.retcode == ReturnCode.Success
    p = nothing

    du = zeros(2)
    f_iip(du, sol.u, nothing, 0)
    @test maximum(du) < 1e-6
end

# OOP Tests
f_oop(u, p, t) = [2 - 2u[1], u[1] - 4u[2]]
u0 = zeros(2)
prob_oop = SteadyStateProblem(f_oop, u0)

for alg in [NLSolveJL()]
    sol = solve(prob_oop, alg)
    @test sol.retcode == ReturnCode.Success
    # test the solver is doing reasonable things for linear solve
    # and that the stats are working properly
    @test 1 <= sol.stats.nf < 10

    du = zeros(2)
    du = f_oop(sol.u, nothing, 0)
    @test maximum(du) < 1e-6
end

# NonlinearProblem Tests

function f_iip(du, u, p)
    du[1] = 2 - 2u[1]
    du[2] = u[1] - 4u[2]
end
u0 = zeros(2)
prob_iip = NonlinearProblem{true}(f_iip, u0)
abstol = 1e-8
for alg in [NLSolveJL()]
    local sol
    sol = solve(prob_iip, alg)
    @test sol.retcode == ReturnCode.Success
    p = nothing

    du = zeros(2)
    f_iip(du, sol.u, nothing)
    @test maximum(du) < 1e-6
end

# OOP Tests
f_oop(u, p) = [2 - 2u[1], u[1] - 4u[2]]
u0 = zeros(2)
prob_oop = NonlinearProblem{false}(f_oop, u0)
for alg in [NLSolveJL()]
    local sol
    sol = solve(prob_oop, alg)
    @test sol.retcode == ReturnCode.Success

    du = zeros(2)
    du = f_oop(sol.u, nothing)
    @test maximum(du) < 1e-6
end

# tolerance tests
f_tol(u, p) = u^2 - 2
prob_tol = NonlinearProblem(f_tol, 1.0)
for tol in [1e-1, 1e-3, 1e-6, 1e-10, 1e-15]
    sol = solve(prob_tol, NLSolveJL(), abstol = tol)
    @test abs(sol.u[1] - sqrt(2)) < tol
end

abstract type SciMLNLSolveAlgorithm <: SciMLBase.AbstractNonlinearAlgorithm end

"""
```julia
NLSolveJL(;
          method=:trust_region,
          autodiff=:central,
          store_trace=false,
          extended_trace=false,
          linesearch=LineSearches.Static(),
          linsolve=(x, A, b) -> copyto!(x, A\\b),
          factor = one(Float64),
          autoscale=true,
          m=10,
          beta=one(Float64),
          show_trace=false,
       )
```

### Keyword Arguments

- `method`: the choice of method for solving the nonlinear system.
- `autodiff`: the choice of method for generating the Jacobian. Defaults to `:central` or
  central differencing via FiniteDiff.jl. The other choices are `:forward`
- `show_trace`: should a trace of the optimization algorithm's state be shown on STDOUT?
  Default: false.
- `extended_trace`: should additional algorithm internals be added to the state trace?
  Default: false.
- `linesearch`: the line search method to be used within the solver method. The choices
  are line search types from
  [LineSearches.jl](https://github.com/JuliaNLSolvers/LineSearches.jl). Defaults to
  `LineSearches.Static()`.
- `linsolve`: a function `linsolve(x, A, b)` that solves `Ax = b`. Defaults to using Julia's
  `\\`.
- `factor``: determines the size of the initial trust region. This size is set to the
  product of factor and the euclidean norm of `u0` if nonzero, or else to factor itself.
  Default: 1.0.
- `autoscale`: if true, then the variables will be automatically rescaled. The scaling
  factors are the norms of the Jacobian columns. Default: true.
- `m`: the amount of history in the Anderson method. Naive "Picard"-style iteration can be
  achieved by setting m=0, but that isn't advisable for contractions whose Lipschitz
  constants are close to 1. If convergence fails, though, you may consider lowering it.
- `beta`: It is also known as DIIS or Pulay mixing, this method is based on the acceleration
  of the fixed-point iteration xₙ₊₁ = xₙ + beta*f(xₙ), where by default beta=1.
- `store_trace``: should a trace of the optimization algorithm's state be stored? Default:
  false.

### Submethod Choice

Choices for methods in `NLSolveJL`:

- `:anderson`: Anderson-accelerated fixed-point iteration
- `:broyden`: Broyden's quasi-Newton method
- `:newton`: Classical Newton method with an optional line search
- `:trust_region`: Trust region Newton method (the default choice)

For more information on these arguments, consult the
[NLsolve.jl documentation](https://github.com/JuliaNLSolvers/NLsolve.jl).
"""
struct NLSolveJL{LSH, LS} <: SciMLNLSolveAlgorithm
    # Refer for tuning parameter choices: https://github.com/JuliaNLSolvers/NLsolve.jl#automatic-differentiation
    method::Symbol
    autodiff::Symbol
    store_trace::Bool
    extended_trace::Bool
    linesearch::LSH
    linsolve::LS
    factor::Real
    autoscale::Bool
    m::Int
    beta::Real
    show_trace::Bool
    # aa_start::Int
    # droptol::Real
end

function NLSolveJL(;
    method = :trust_region,
    autodiff = :central,
    store_trace = false,
    extended_trace = false,
    linesearch = LineSearches.Static(),
    linsolve = (x, A, b) -> copyto!(x, A \ b),
    factor = one(Float64),
    autoscale = true,
    m = 10,
    beta = one(Float64),
    show_trace = false)
    NLSolveJL{typeof(linesearch), typeof(linsolve)}(method, autodiff, store_trace,
        extended_trace, linesearch, linsolve,
        factor, autoscale, m, beta, show_trace)
end

function SciMLBase.__solve(prob::Union{SciMLBase.AbstractSteadyStateProblem,
        SciMLBase.AbstractNonlinearProblem},
    alg::algType,
    args...;
    abstol = 1e-6,
    maxiters = 1000,
    kwargs...) where {algType <: SciMLNLSolveAlgorithm}
    if typeof(prob.u0) <: Number
        u0 = [prob.u0]
    else
        u0 = deepcopy(prob.u0)
    end

    iip = isinplace(prob)

    sizeu = size(prob.u0)
    p = prob.p

    # unwrapping alg params
    method = alg.method
    autodiff = alg.autodiff
    store_trace = alg.store_trace
    extended_trace = alg.extended_trace
    linesearch = alg.linesearch
    linsolve = alg.linsolve
    factor = alg.factor
    autoscale = alg.autoscale
    m = alg.m
    beta = alg.beta
    show_trace = alg.show_trace

    ### Fix the more general function to Sundials allowed style
    if typeof(prob.f) <: ODEFunction
        t = Inf
        if !iip && typeof(prob.u0) <: Number
            f! = (du, u) -> (du .= prob.f(first(u), p, t); Cint(0))
        elseif !iip && typeof(prob.u0) <: Vector{Float64}
            f! = (du, u) -> (du .= prob.f(u, p, t); Cint(0))
        elseif !iip && typeof(prob.u0) <: AbstractArray
            f! = (du, u) -> (du .= vec(prob.f(reshape(u, sizeu), p, t)); Cint(0))
        elseif typeof(prob.u0) <: Vector{Float64}
            f! = (du, u) -> prob.f(du, u, p, t)
        else # Then it's an in-place function on an abstract array
            f! = (du, u) -> (prob.f(reshape(du, sizeu), reshape(u, sizeu), p, t);
            du = vec(du);
            0)
        end
    elseif typeof(prob.f) <: NonlinearFunction
        if !iip && typeof(prob.u0) <: Number
            f! = (du, u) -> (du .= prob.f(first(u), p); Cint(0))
        elseif !iip && typeof(prob.u0) <: Vector{Float64}
            f! = (du, u) -> (du .= prob.f(u, p); Cint(0))
        elseif !iip && typeof(prob.u0) <: AbstractArray
            f! = (du, u) -> (du .= vec(prob.f(reshape(u, sizeu), p)); Cint(0))
        elseif typeof(prob.u0) <: Vector{Float64}
            f! = (du, u) -> prob.f(du, u, p)
        else # Then it's an in-place function on an abstract array
            f! = (du, u) -> (prob.f(reshape(du, sizeu), reshape(u, sizeu), p);
            du = vec(du);
            0)
        end
    end

    resid = similar(u0)
    f!(resid, u0)

    if SciMLBase.has_jac(prob.f)
        if !iip && typeof(prob.u0) <: Number
            g! = (du, u) -> (du .= prob.f.jac(first(u), p); Cint(0))
        elseif !iip && typeof(prob.u0) <: Vector{T} where {T <: Number}
            g! = (du, u) -> (du .= prob.f.jac(u, p); Cint(0))
        elseif !iip && typeof(prob.u0) <: AbstractArray
            g! = (du, u) -> (du .= vec(prob.f.jac(reshape(u, sizeu), p)); Cint(0))
        elseif typeof(prob.u0) <: Vector{T} where {T <: Number}
            g! = (du, u) -> prob.f.jac(du, u, p)
        else # Then it's an in-place function on an abstract array
            g! = (du, u) -> (prob.f.jac(reshape(du, sizeu), reshape(u, sizeu), p);
            du = vec(du);
            0)
        end
        if prob.f.jac_prototype !== nothing
            J = zero(prob.f.jac_prototype)
            df = OnceDifferentiable(f!, g!, u0, resid, J)
        else
            df = OnceDifferentiable(f!, g!, u0, resid)
        end
    else
        df = OnceDifferentiable(f!, u0, resid, autodiff = autodiff)
    end

    original = nlsolve(df, u0,
        ftol = abstol,
        iterations = maxiters,
        method = method,
        store_trace = store_trace,
        extended_trace = extended_trace,
        linesearch = linesearch,
        linsolve = linsolve,
        factor = factor,
        autoscale = autoscale,
        m = m,
        beta = beta,
        show_trace = show_trace)

    u = reshape(original.zero, size(u0))
    f!(resid, u)
    retcode = original.x_converged || original.f_converged ? ReturnCode.Success :
              ReturnCode.Failure
    stats = SciMLBase.NLStats(original.f_calls,
        original.g_calls,
        original.g_calls,
        original.g_calls,
        original.iterations)
    SciMLBase.build_solution(prob, alg, u, resid; retcode = retcode,
        original = original, stats = stats)
end
